#!/bin/bash
# Load modules
echo Loading modules...
module purge

export SOFTWARE_STAGE=2020
export OTHERSTAGES=/p/software/jurecadc/otherstages
export SOFTWARE_DIR=/p/project/cjinm16/schiffer1/software
export SOFTWARE_STAGES_DIR=${SOFTWARE_DIR}/stages/
export SOFTWARE_STAGE_DIR=${SOFTWARE_STAGES_DIR}/${SOFTWARE_STAGE}
export SOFTWARE_STAGE_MODULES=${SOFTWARE_STAGE_DIR}/modules/
export ATLAS_MODULE=atlas/OpenMPI_PyTorch

module use $OTHERSTAGES &> /dev/null
module use ${SOFTWARE_STAGE_MODULES} &> /dev/null

module load ${ATLAS_MODULE}
echo Modules loaded

# Environment variables
export SCRATCH_USER=/p/scratch/cjinm16/schiffer1/
export OUTPUT_SPACING=16

# Set annotation directory (assume we are in the experiment folder)
export BRAIN=__BRAIN__
export ATLAS_ANNOTATION_DIR=`pwd`/annotations/
export ATLAS_ANNOTATION_FILE="B${BRAIN}_{slice:04d}_annotations.hdf5"

# Make prediction and run evaluation
srun --cpus-per-task 4 atlas dl predict `pwd` --verbose --output-spacing ${OUTPUT_SPACING} --overwrite
srun --cpus-per-task 4 atlas dl evaluate `pwd` --verbose --embedded-pred-to-hdf5 --output-spacing ${OUTPUT_SPACING}
